unit UObiekty;
interface
type

 PPole = ^TPole;

 TProc = procedure(Kierunek,R,G,B,XX,YY:byte);

 TKPole = array[1..8] of record
                          R,G,B:byte;
                          Bl:boolean;
                         end;

 PRys = ^TRys;
 TRys = record
   Ikona:pointer;
   Next: PRys;
 end;

 TPole = object
   X,Y:integer;
   Kod:string[4];
   Proc:TProc;
   Rys,VRys:PRys;
   KPole:TKPole;
   B1,B2:boolean;
   constructor Init(AX,AY:integer;ARys:PRys;AKod:string;APr:TProc);
   destructor Koniec;
   procedure Wykonaj(Kierunek,R,G,B,XX,YY:byte);
   procedure Wyswietl;
   procedure RysujLinie;
   procedure CzyscKPole;
   procedure Steruj;
   procedure WyswietlNastepny;
   procedure WyswietlPierwszy;
 end;

implementation

uses UDane,Graph,m2mouse,UProcedury,UMouse;

procedure ZniszczRys(Rys:PRys);
var
 Pomoc:PRys;
begin
 if Rys<>nil then
  begin
   Pomoc:=Rys;
   Rys:=Rys^.Next;
   Pomoc^.Next:=nil;
   while Rys<>nil do
    begin
     Pomoc:=Rys;
     Rys:=Rys^.Next;
     dispose(Pomoc);
    end;
  end;
end;

{ TPole }

constructor TPole.Init(AX,AY:integer;ARys:PRys;AKod:string;APr:TProc);
var
 a:byte;
begin
 X:=AX;
 Y:=AY;
 Kod:=AKod;
 Rys:=ARys;
 VRys:=Rys;
 for a:=1 to 8 do
  begin
   KPole[a].R:=0;
   KPole[a].G:=0;
   KPole[a].B:=0;
   KPole[a].Bl:=false;
  end;
 Proc:=APr;
 B1:=false;
 B2:=false;
{***************************}
 if not (Kod[1] in [' ','#','=','O']) then
  begin
   a:=ord(Kod[2]);
   if a=32 then
    a:=1
   else
    a:=a-47;
   if Kod[1] in ['R','%'] then
    begin
     while a>4 do
      a:=a-4;
    end
   else
    if a>8 then
     a:=a-8;
   if a=1 then Kod[2]:=' '
   else
    Kod[2]:=chr(a+47);
  end;
{***************************}
end;
destructor TPole.Koniec;
begin
 ZniszczRys(Rys);
end;
procedure TPole.Wyswietl;
begin
 PutImage(X,Y,Rys^.Ikona^,NormalPut);
end;
procedure TPole.WyswietlNastepny;
var
 s:string;
begin
   s:=copy(Kod,1,2);
   if (s[1]<>'=')and(s<>'#4')and(s<>'#5') then
    begin
     Rys:=Rys^.Next;
     PutImage(X,Y,Rys^.Ikona^,NormalPut);
    end;
end;
procedure TPole.WyswietlPierwszy;
begin
 PutImage(X,Y,VRys^.Ikona^,NormalPut);
end;
procedure TPole.Wykonaj(Kierunek,R,G,B,XX,YY:byte);
begin
 Proc(Kierunek,R,G,B,XX,YY);
end;
function PodajKolor(R,G,B:byte):byte;
begin
 if (R=0)and(G=0)and(B=0) then
  PodajKolor:=0;
 if (R=0)and(G=0)and(B=1) then
  PodajKolor:=KB;
 if (R=0)and(G=1)and(B=0) then
  PodajKolor:=KG;
 if (R=0)and(G=1)and(B=1) then
  PodajKolor:=KGB;
 if (R=1)and(G=0)and(B=0) then
  PodajKolor:=KR;
 if (R=1)and(G=0)and(B=1) then
  PodajKolor:=KRB;
 if (R=1)and(G=1)and(B=0) then
  PodajKolor:=KRG;
 if (R=1)and(G=1)and(B=1) then
  PodajKolor:=KRGB;
end;
procedure TPole.RysujLinie;
var
 Kol:byte;
 a:byte;
 WX,WY:integer;
 DR,DG,DB:byte;
 CKod:char;
begin
 for a:=1 to 8 do
  if (KPole[a].R=0)and(KPole[a].G=0)and
     (KPole[a].B=0)and(KPole[a].Bl) then
   begin
    KPole[a].Bl:=false;
    HideCursor;
    Wyswietl;
    WX:=(X div 32)+1;
    WY:=(Y div 32)+1;
    if WY>1 then
     Plansza[WX,WY-1]^.Wyswietl;
    if WX<20 then
     Plansza[WX+1,WY]^.Wyswietl;
    if WY>13 then
     Plansza[WX,WY+1]^.Wyswietl;
    if WX>1 then
     Plansza[WX-1,WY]^.Wyswietl;
    WyswietlDane;
    ShowCursor;
   end;
 DR:=0;DG:=0;DB:=0;
 CKod:=Kod[3];
 case CKod of
  ' ':begin DR:=1;DG:=1;DB:=1; end;
  'R':begin DR:=1;DG:=0;DB:=0; end;
  'G':begin DR:=0;DG:=1;DB:=0; end;
  'B':begin DR:=0;DG:=0;DB:=1; end;
  'Y':begin DR:=1;DG:=1;DB:=0; end;
  'C':begin DR:=0;DG:=1;DB:=1; end;
  'M':begin DR:=1;DG:=0;DB:=1; end;
 end;
 for a:=1 to 8 do
  begin
   Kol:=PodajKolor(KPole[a].R,KPole[a].G,KPole[a].B);
   if Kol<>0 then
    begin
     if a in [1,3,5,7] then
      begin
       B1:=false;
       if not B2 then
        begin
         B1:=true;
         B2:=true;
        end;
       if (KPole[a].R<>DR)or(KPole[a].G<>DG)or(KPole[a].B<>DB) then
        B1:=false;
      end;
     case a of
      1:begin
         SetColor(Kol);
         Line(X+15,Y,X+15,Y+15);
         Line(16+X,Y,16+X,Y+15);
        end;
      2:begin
         SetColor(Kol);
         Line(X+15,Y+16,X+15,Y+31);
         Line(16+X,Y+16,16+X,Y+31);
        end;
      5:begin
         SetColor(Kol);
         Line(X+16,Y+15,X+31,Y+15);
         Line(X+16,Y+16,X+31,Y+16);
        end;
      6:begin
         SetColor(Kol);
         Line(X,Y+15,X+15,Y+15);
         Line(X,Y+16,X+15,Y+16);
        end;
      3:begin
         SetColor(Kol);
         Line(X+16,Y+15,X+31,Y);
         Line(X+15,Y+15,X+30,Y);
         Line(X+16,Y+16,X+31,Y+1);
        end;
      4:begin
         SetColor(Kol);
         Line(X,Y+31,X+15,Y+16);
         Line(X-1,Y+31,X+15,Y+15);
         Line(X,Y+32,X+16,Y+16);
        end;
      8:begin
         SetColor(Kol);
         Line(X,Y,X+15,Y+15);
         Line(X+1,Y,X+16,Y+15);
         Line(X,Y+1,X+15,Y+16);
        end;
      7:begin
         SetColor(Kol);
         Line(X+16,Y+16,X+31,Y+31);
         Line(X+15,Y+16,X+31,Y+32);
         Line(X+16,Y+15,X+32,Y+31);
        end;
     end;
    end
  end;
end;
procedure TPole.CzyscKPole;
var
 a:byte;
begin
 for a:=1 to 8 do
  begin
   KPole[a].R:=0;
   KPole[a].G:=0;
   KPole[a].B:=0;
  end;
 B1:=false;
 B2:=false;
end;
procedure TPole.Steruj;
var
 XX,YY,Buttons:word;
 a:byte;
 NRys,NVRys:PRys;
 NProc:TProc;
 NKod:string4;
procedure ZmienCursor;
begin
 if (Kod[4]=' ')or(Kod[1]=' ') then
  DefineMouseCursor(1,1,@MousDat1);
 if (Kod[4]='.')and(Kod[1]<>' ') then
  DefineMouseCursor(1,1,@MousDat3);
 if Kod[4]='r' then
  DefineMouseCursor(1,1,@MousDat2);
 if (Kod[1]<>' ')and(Kod[4]<>' ') then
end;
begin
 GReadMouse(XX,YY,Buttons);
 if (XX>X)and(XX<X+31)and
    (YY>Y)and(YY<Y+31) then
  begin
    ZmienCursor;
    if Buttons=LeftButton then
     begin
      repeat
       GReadMouse(XX,YY,Buttons);
      until Buttons=NoButton;
      a:=ord(Kod[2]);
      if a=32 then
       begin
        if (Kod[1]='R')or(Kod[1]='%') then
         Kod[2]:='3'
        else
         Kod[2]:='7';
       end
      else
       begin
        dec(a);
        if a=ord('0') then a:=32;
        Kod[2]:=chr(a);
       end;
      HideCursor;
      ZmienCursor;
      WyswietlNastepny;
{      OutTextXY(X+5,Y+5,Kod[2]);}
      ShowCursor;
     end;
   if Kod[4]='.' then
    if Buttons=RightButton then
     begin
      repeat
       GReadMouse(XX,YY,Buttons);
      until Buttons=NoButton;
      NRys:=Rys;
      NVRys:=VRys;
      NKod:=Kod;
      NProc:=Proc;

      Rys:=Pole^.Rys;
      VRys:=Pole^.VRys;
      Kod:=Pole^.Kod;
      Proc:=Pole^.Proc;

      Pole^.VRys:=NVRys;
      Pole^.Rys:=NRys;
      Pole^.Kod:=NKod;
      Pole^.Proc:=NProc;

      HideCursor;
      ZmienCursor;
      Wyswietl;
      Pole^.Wyswietl;
      ShowCursor;
     end;
  end;
end;
end.