unit UPlikSpis;
interface
uses objects,dos,Tools,Grafika,Fonty,Lista;
const
 CPlikSpis = CTekstOkno;
type
 PPlikSpis = ^TPlikSpis;
 TPlikSpis = object(TOkno)
   Katalog:string;
   Prz:array[1..20] of PTekstPrzycisk4;
   VScrollBar:PVScrollBar;
   C:PCzcionka;
   Lista:PStringLista;
   SR:SearchRec;
   Adr:word;
   Nazwa:string;
   Numer:word;
   constructor Init(R:TRect;AKatalog:string;AC:PCzcionka);
   procedure Rysuj;virtual;
   procedure RysujTekst;
   procedure Spisz;
   function OdczytajNazwe:string;
   procedure RysujListe;virtual;
   function Steruj:boolean;virtual;
   function GetPalette:PPalette;virtual;
   destructor Koniec;
 end;
implementation
constructor TPlikSpis.Init(R:TRect;AKatalog:string;AC:PCzcionka);
var
 a:byte;
begin
 R.B.Y:=R.A.Y+25+10*20;
 Adr:=1;
 Nazwa:='';
 inherited Init(R);
 Katalog:=AKatalog;
 R.A.X:=R.B.X-15;
 R.A.Y:=R.A.Y+17;
 C:=AC;
 New(Lista,Init);
 FindFirst(Katalog,AnyFile,SR);
 Spisz;
 for a:=1 to 20 do
  Prz[a]:=nil;
 if Lista^.PD>19 then
  begin
   new(VScrollBar,Init(R.A.X,R.A.Y,R.B.Y-R.A.Y-3));
   VScrollBar^.UstawParam(1,1+Lista^.PD div 20,1,1);
  end
 else
  VScrollBar:=nil;
end;
destructor TPlikSpis.Koniec;
var
 a:byte;
begin
 inherited Koniec;
 if VScrollBar<>nil then
  dispose(VScrollBar,Koniec);
 dispose(Lista,Koniec);
 for a:=1 to 20 do
  if Prz[a]<>nil then
   dispose(Prz[a],Koniec);
end;
function TPlikSpis.GetPalette:PPalette;
const
 P:String[length(CPlikSpis)] = CPlikSpis;
begin
 GetPalette:=@P;
end;

procedure TPlikSpis.Rysuj;
begin
 inherited Rysuj;
 RysujTekst;
 if VScrollBar<>nil then
  VScrollBar^.Rysuj;
 RysujListe;
end;
function TPlikSpis.OdczytajNazwe:string;
begin
 OdczytajNazwe:=Nazwa;
end;
procedure TPlikSpis.RysujListe;
var
 Ilosc:word;
 a:word;
 R:TRect;
begin
 Ilosc:=Lista^.PD;
 if Ilosc>20+Adr-1 then Ilosc:=20+Adr-1;
 for a:=Adr to Ilosc do
  begin
   if VScrollBar<>nil then
    R.Assign(W.A.X+10,W.A.Y+20+(a-Adr)*10,W.B.X-24,W.A.Y+20+(a-Adr)*10+9)
   else
    R.Assign(W.A.X+10,W.A.Y+20+(a-Adr)*10,W.B.X-10,W.A.Y+20+(a-Adr)*10+9);
   New(Prz[a-Adr+1],Init(R,fl2,Lista^.Napisz(a-1),C));
   Prz[a-Adr+1]^.Rysuj;
  end;
end;
procedure TPlikSpis.RysujTekst;
begin
 UstawKolor(7);
 NapiszXYFnt(W.A.X+5,W.A.Y+3,'Odczytaj',C);
end;
procedure TPlikSpis.Spisz;
begin
 if (SR.Name<>'.')and(SR.Name<>'..')and(SR.Attr<>Directory) then
  Lista^.Dodaj(SR.Name);
 FindNext(SR);
 While DosError=0 do
  Spisz;
end;
function TPlikSpis.Steruj:boolean;
var
 a:byte;
 B:boolean;
 s:string;
begin
 B:=false;
 if Widoczne then
  begin
   for a:=1 to 20 do
    if Prz[a]<>nil then
     if Prz[a]^.Steruj then
      begin
       B:=true;
       Nazwa:=Prz[a]^.Tekst;
       Numer:=Adr-1+a;
       Schowaj;
      end;
   if VScrollBar=nil then
    B:=inherited Steruj or B
   else
    begin
     B:= inherited Steruj or B;
     if VScrollBar^.Steruj then
      begin
       Adr:=(VScrollBar^.Odczytaj-1)*20+1;
       for a:=1 to 20 do
        begin
         if Prz[a]<>nil then
          dispose(Prz[a],Koniec);
         Prz[a]:=nil;
        end;
       Blok(W.A.X+3,W.A.Y+17,W.B.X-16,W.B.Y-3,ord(GetPalette^[6]));
       RysujListe;
      end;
    end;
  end;
 Steruj:=B;
end;
end.